image: docker:19.03
variables:
#  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
  DOCKER_COMPOSE_SERVICE: timers-service
  DOCKER_TLS_CERTDIR: ""
  GIT_SUBMODULE_STRATEGY: recursive
#services:
#  - name: docker:19.03-dind
before_script:
  - 'which ssh-agent || ( apk add --update openssh-client )'
  - eval $(ssh-agent -s)
  - echo "${SSH_PRIVATE_KEY}" | tr -d '\r' | ssh-add - > /dev/null
  - mkdir -p ~/.ssh
  - touch ~/.ssh/known_hosts
  - chmod 700 ~/.ssh
stages:
  - deploy

Deploy develop:
  stage: deploy
  tags:
    - actech-runner
  only:
    - develop
  script:
    - ssh-keyscan -H dev.actech.alx > ~/.ssh/known_hosts
    - docker build --no-cache -t ${CI_PROJECT_PATH}:${CI_BUILD_REF_NAME} .
#    - docker images -q --filter "dangling=true" | xargs -r docker rmi -f
    - docker save -o transfer_$DOCKER_COMPOSE_SERVICE.tar ${CI_PROJECT_PATH}:${CI_BUILD_REF_NAME}
    - scp transfer_${DOCKER_COMPOSE_SERVICE}.tar root@dev.actech.alx:/var/lib/docker/
    - ssh -t -t -o ConnectTimeout=300 -o BatchMode=yes -o StrictHostKeyChecking=no root@dev.actech.alx /bin/bash -c "pwd && cd /actech && docker load -i /var/lib/docker/transfer_$DOCKER_COMPOSE_SERVICE.tar && rm -f /var/lib/docker/transfer_${DOCKER_COMPOSE_SERVICE}.tar && docker-compose stop $DOCKER_COMPOSE_SERVICE && docker-compose rm -f && docker-compose up -d $DOCKER_COMPOSE_SERVICE && exit"

Deploy uat:
  stage: deploy
  tags:
    - actech-runner
  only:
    - uat
  script:
    - ssh-keyscan -H uat.actech.msm.alx > ~/.ssh/known_hosts
    - docker build --no-cache -t ${CI_PROJECT_PATH}:${CI_BUILD_REF_NAME} .
#    - docker images -q --filter "dangling=true" | xargs -r docker rmi -f
    - docker save -o transfer_$DOCKER_COMPOSE_SERVICE.tar ${CI_PROJECT_PATH}:${CI_BUILD_REF_NAME}
    - scp transfer_${DOCKER_COMPOSE_SERVICE}.tar root@uat.actech.msm.alx:/actech/
    - ssh -t -t -o ConnectTimeout=300 -o BatchMode=yes -o StrictHostKeyChecking=no root@uat.actech.msm.alx /bin/bash -c "pwd && cd /actech && docker load -i transfer_$DOCKER_COMPOSE_SERVICE.tar && rm -f transfer_${DOCKER_COMPOSE_SERVICE}.tar && docker-compose stop $DOCKER_COMPOSE_SERVICE && docker-compose rm -f && docker-compose up -d $DOCKER_COMPOSE_SERVICE && exit"

Deploy promo:
  stage: deploy
  tags:
    - actech-runner
  only:
    - promo
  script:
    - ssh-keyscan -H promo.actech.msm.alx > ~/.ssh/known_hosts
    - docker build --no-cache -t ${CI_PROJECT_PATH}:${CI_BUILD_REF_NAME} .
#    - docker images -q --filter "dangling=true" | xargs -r docker rmi -f
    - docker save -o transfer_$DOCKER_COMPOSE_SERVICE.tar ${CI_PROJECT_PATH}:${CI_BUILD_REF_NAME}
    - scp transfer_${DOCKER_COMPOSE_SERVICE}.tar root@promo.actech.msm.alx:/actech/
    - ssh -t -t -o ConnectTimeout=300 -o BatchMode=yes -o StrictHostKeyChecking=no root@promo.actech.msm.alx /bin/bash -c "pwd && cd /actech && docker load -i transfer_$DOCKER_COMPOSE_SERVICE.tar && rm -f transfer_${DOCKER_COMPOSE_SERVICE}.tar && docker-compose stop $DOCKER_COMPOSE_SERVICE && docker-compose rm -f && docker-compose up -d $DOCKER_COMPOSE_SERVICE && exit"
    - docker images -q --filter "dangling=true" | xargs -r docker rmi -f

Deploy demo:
  stage: deploy
  tags:
    - actech-runner
  only:
    - demo
  script:
# For some reason h-r address aka demo.actech.msm.alx does not work
    - ssh-keyscan -H 10.4.10.33 > ~/.ssh/known_hosts
    - docker build --no-cache -t ${CI_PROJECT_PATH}:${CI_BUILD_REF_NAME} .
#    - docker images -q --filter "dangling=true" | xargs -r docker rmi -f
    - docker save -o transfer_$DOCKER_COMPOSE_SERVICE.tar ${CI_PROJECT_PATH}:${CI_BUILD_REF_NAME}
    - scp transfer_${DOCKER_COMPOSE_SERVICE}.tar root@10.4.10.33:/actech/
    - ssh -t -t -o ConnectTimeout=300 -o BatchMode=yes -o StrictHostKeyChecking=no root@10.4.10.33 /bin/bash -c "pwd && cd /actech && docker load -i transfer_$DOCKER_COMPOSE_SERVICE.tar && rm -f transfer_${DOCKER_COMPOSE_SERVICE}.tar && docker-compose stop $DOCKER_COMPOSE_SERVICE && docker-compose rm -f && docker-compose up -d $DOCKER_COMPOSE_SERVICE && exit"

Deploy prod:
  stage: deploy
  tags:
    - actech-runner
  only:
    - master
  script:
    - ssh-keyscan -H prod.actech.alx > ~/.ssh/known_hosts
    - docker build --no-cache -t ${CI_PROJECT_PATH}:${CI_BUILD_REF_NAME} .
#    - docker images -q --filter "dangling=true" | xargs -r docker rmi -f
    - docker save -o transfer_$DOCKER_COMPOSE_SERVICE.tar ${CI_PROJECT_PATH}:${CI_BUILD_REF_NAME}
    - scp transfer_${DOCKER_COMPOSE_SERVICE}.tar root@prod.actech.alx:/actech/
    - ssh -t -t -o ConnectTimeout=300 -o BatchMode=yes -o StrictHostKeyChecking=no root@prod.actech.alx /bin/bash -c "pwd && cd /actech && docker load -i transfer_$DOCKER_COMPOSE_SERVICE.tar && rm -f transfer_${DOCKER_COMPOSE_SERVICE}.tar && docker-compose stop $DOCKER_COMPOSE_SERVICE && docker-compose rm -f && docker-compose up -d $DOCKER_COMPOSE_SERVICE && exit"

Deploy beta-aws:
  stage: deploy
  tags:
    - beta-actech
  only:
    - beta-aws
  script:
    - docker build --no-cache -t ${CI_PROJECT_PATH}:${CI_BUILD_REF_NAME} .
    - docker images -q --filter "dangling=true" | xargs -r docker rmi -f
